<?php
namespace Teknisa\PLA\Modules\Mymeals\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\DataSet;

class Pla99901ParametrizacaoMymealsController extends \Teknisa\GER\Controllers\TeknisaCrud {

    protected $crudService;
    protected $Pla99901ParametrizacaoMymealsService;

    public function __construct($crudService, $parameterBag, $Pla99901ParametrizacaoMymealsService) {
        $this->crudService = $crudService;
        $this->parameterBag = $parameterBag;
        $this->Pla99901ParametrizacaoMymealsService = $Pla99901ParametrizacaoMymealsService;
    }

    public function retornaOperador(DTO\Request\Filter $request, DTO\Response $response){
        $this->dataSourceName = "pla99901_operador_servoper";
        $this->parameterBagColumns = array('NRORG');

        $this->find($request, $response);
    }

    public function retornaServicoOperador(DTO\Request\Filter $request, DTO\Response $response){
        $this->dataSourceName = "pla99901_servico_servoper_operador";
        $this->parameterBagColumns = array('CDOPERADOR', 'NRORG');

        $this->find($request, $response);
    }
    
    public function salvaParametrizacao(DTO\Request\Row $request, DTO\Response $response){
        $row = $request->getRow();
        $contador = 1;
        $this->Pla99901ParametrizacaoMymealsService->iniciaTransacao();

        try {
            if ($row['__is_new']) {
                foreach ($row['LISTASERVICO'] as $paramservicooper) {
                    $this->Pla99901ParametrizacaoMymealsService->salvaParamservicooper($paramservicooper['CDFILIAL'], $paramservicooper['CDSERVFILI'], $row);
                    $retorno = $this->Pla99901ParametrizacaoMymealsService->insereServoper($paramservicooper['CDFILIAL'], $paramservicooper['CDSERVFILI'], $row['CDOPERADOR']);
                    if ($retorno == false) $contador = 0;
                }
            } else {
                foreach ($row['LISTASERVICO'] as $paramservicooper) {
                    $this->Pla99901ParametrizacaoMymealsService->salvaParamservicooper($paramservicooper['CDFILIAL'], $paramservicooper['CDSERVFILI'], $row);
                }
            }
            $this->Pla99901ParametrizacaoMymealsService->flush();
            $this->Pla99901ParametrizacaoMymealsService->commit();

            $response->addDataset(new \Zeedhi\Framework\DataSource\DataSet('RETORNO', array($contador)));
        } catch (\Exception $e) {
            $this->Pla99901ParametrizacaoMymealsService->rollback();
            $response->setError(new \Zeedhi\Framework\DTO\Response\Error($e->getMessage(), 1));
        }
    }

    public function deletaParametrizacao(DTO\Request\Row $request, DTO\Response $response){
        $rows = $request->getRow();

        try {
            $this->Pla99901ParametrizacaoMymealsService->iniciaTransacao();

            if (array_key_exists('CDFILIAL', $rows[0]) && array_key_exists('CDSERVFILI', $rows[0])) {
                foreach($rows as $row){
                    $this->Pla99901ParametrizacaoMymealsService->deletaServoper($row['CDOPERADOR'], $row['CDFILIAL'], $row['CDSERVFILI']);
                }
            } else {
                foreach($rows as $row) {
                    $this->Pla99901ParametrizacaoMymealsService->deletaServoperOperador($row['CDOPERADOR']);
                }
            }

            $this->Pla99901ParametrizacaoMymealsService->flush();
            $this->Pla99901ParametrizacaoMymealsService->commit();
        } catch(\Exception $e){
            $this->Pla99901ParametrizacaoMymealsService->rollback();
            $response->setError(new \Zeedhi\Framework\DTO\Response\Error($e->getMessage(), 1));
        }
    }
    
    public function deletaTipoprat(DTO\Request\Row $request, DTO\Response $response){
        $rows = $request->getRow();

        try {
            $this->Pla99901ParametrizacaoMymealsService->iniciaTransacao();

            foreach($rows as $row) {
                $this->Pla99901ParametrizacaoMymealsService->deletaTipoprat($row['CDFILIAL'], $row['CDSERVFILI']);
            }

            $this->Pla99901ParametrizacaoMymealsService->flush();
            $this->Pla99901ParametrizacaoMymealsService->commit();
        } catch(\Exception $e){
            $this->Pla99901ParametrizacaoMymealsService->rollback();
            $response->setError(new \Zeedhi\Framework\DTO\Response\Error($e->getMessage(), 1));
        }
    }

    public function salvaTipoprat(DTO\Request\Row $request, DTO\Response $response)
    {
        $row = $request->getRow();

        $cdfilial = $row['CDFILIAL'];
        $cdservfili = $row['CDSERVFILI'];

        try{
            $this->Pla99901ParametrizacaoMymealsService->iniciaTransacao();

            $paramtpratserv = $this->Pla99901ParametrizacaoMymealsService->retornaParamtpratserv();
            if($paramtpratserv){
                $nrparamtpratserv = $paramtpratserv[0]->getNrparamtpratserv();
            }else{
                $nrparamtpratserv = 0;
            }

            foreach($row['LISTATIPOPRAT'] as $cdtipoprat){
                $registroNovo = $this->existeParamtpratserv($paramtpratserv, $cdfilial, $cdservfili, $cdtipoprat, $response);
                if($registroNovo) {
                    $nrparamtpratserv++;
                    $this->Pla99901ParametrizacaoMymealsService->insereTipoprat($nrparamtpratserv, $cdfilial, $cdservfili, $cdtipoprat);
                }
            }

            $this->Pla99901ParametrizacaoMymealsService->flush();
            $this->Pla99901ParametrizacaoMymealsService->commit();

        } catch(\Exception $e){
            $this->Pla99901ParametrizacaoMymealsService->rollback();
            $response->setError(new \Zeedhi\Framework\DTO\Response\Error($e->getMessage(), 1));
        }
    }

    public function existeParamtpratserv($paramtpratserv, $cdfilialNovo, $cdservfiliNovo, $cdtipopratNovo, $response){
        foreach($paramtpratserv as $pratserv){
            $cdfilial = $pratserv->getCdfilial();
            $cdservfili = $pratserv->getCdservfili();
            $cdtipoprat = $pratserv->getCdtipoprat();

            if($cdfilial == $cdfilialNovo && $cdservfili == $cdservfiliNovo && $cdtipoprat == $cdtipopratNovo){
                $response->addDataSet(new DataSet('errorInfo', array('CDTIPOPRAT' => $cdtipoprat, 'CDSERVFILI' => $cdservfili, 'CDFILIAL' => $cdfilial)));
                throw new \Exception('tipoPratoJaExisteServicoUnidade');
            }
        }

        return true;
    }

}